package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.StorageBusBlockEntity
import ru.dbotthepony.mc.otm.container.ItemFilterNetworkSlot
import ru.dbotthepony.mc.otm.menu.widget.BooleanPlayerInputWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class StorageBusMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: StorageBusBlockEntity? = null
) : MatteryPoweredMenu(
	MMenus.STORAGE_BUS, p_38852_, inventory, tile
)  {
	val busFilterSlots: List<ItemFilterNetworkSlot>
	val busFilterState: BooleanPlayerInputWidget

	init {
		if (tile != null) {
			busFilterSlots = addFilterSlots(tile.filter)
			busFilterState = BooleanPlayerInputWidget(this, tile.filter::isWhitelist)
		} else {
			busFilterSlots = addFilterSlots(StorageBusBlockEntity.MAX_FILTERS)
			busFilterState = BooleanPlayerInputWidget(this).asClient()
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart() = 0
	override fun getWorkingSlotEnd() = 1
}
