package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.StorageImporterBlockEntity
import ru.dbotthepony.mc.otm.block.entity.StoragePowerSupplierBlockEntity
import ru.dbotthepony.mc.otm.menu.data.ImpreciseFractionDataContainer
import ru.dbotthepony.mc.otm.menu.widget.BooleanPlayerInputWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class StoragePowerSupplierMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: StoragePowerSupplierBlockEntity? = null
) : MatteryPoweredMenu(
	MMenus.STORAGE_POWER_SUPPLIER, p_38852_, inventory, tile
)  {
	val totalTransferred = ImpreciseFractionDataContainer()

	init {
		addInventorySlots()

		addDataContainer(totalTransferred)
	}

	override fun broadcastChanges() {
		if (tile is StoragePowerSupplierBlockEntity) {
			totalTransferred.value = tile.powerSupplied
		}

		super.broadcastChanges()
	}

	override fun getWorkingSlotStart() = 0
	override fun getWorkingSlotEnd() = 1
}
